//////////////////////////////////////////////////////////////////////////
// BeDC.h                                                               //
// The header file to use with BeDC                                     //
//                                                                      //
// Written By: Magnus Landahl                                           //
// E-Mail: magnus.landahl@swipnet.se                                    //
//                                                                      //
// Copyright © Magnus Landahl - Stockholm 2000                           //
//////////////////////////////////////////////////////////////////////////					

#ifndef	_BE_DC_H_
#define _BE_DC_H_

#define DC_MESSAGE		 	'___0'
#define	DC_SUCCESS		 	DC_MESSAGE + 1
#define DC_ERROR		 	DC_MESSAGE + 2
#define DC_SEPARATOR		DC_MESSAGE + 3

#define BEDC_MESSAGE	'bedc'

#include <TypeConstants.h>
#include <SupportDefs.h>
#include <Messenger.h>
#include <Message.h>
#include <String.h>
#include <Point.h>
#include <Rect.h>

class BeDC
{
	public:
		BeDC(const char *c_name){
			name = (char *)c_name;
		}
				
		void SendMessage(char *text, int32 type = DC_MESSAGE){
			BMessage message(BEDC_MESSAGE);
			message.AddString(	"name", name);
			message.AddInt32(	"type", type);
			message.AddString(	"text", text);
			BMessenger messenger("application/x-vnd.Be-BeDCApp");
			if (messenger.IsValid()) messenger.SendMessage(&message);	
		}
		
		void AddSeparator(){
			SendMessage("Separator", DC_SEPARATOR);
		}
		
		void SendInt(int32 integer, const char *desc = NULL, int32 type = DC_MESSAGE){
			str.SetTo("");
			if (desc != NULL) 	str << desc << ": "; else
								str << "Integer: ";
			str << integer;
			SendMessage((char *)str.String(),type); 
		}
		
		void SendInt(int64 integer, const char *desc = NULL, int32 type = DC_MESSAGE){
			str.SetTo("");
			if (desc != NULL) 	str << desc << ": "; else
								str << "Integer: ";
			str << integer;
			SendMessage((char *)str.String(),type); 
		}
		
		void SendPoint(BPoint point, const char *desc = NULL, int32 type = DC_MESSAGE){
			str.SetTo("");
			if (desc != NULL) 	str << desc << ": "; else
								str << "Point: ";
			str << "X: " << point.x  << " Y: " << point.y;
			SendMessage((char *)str.String(),type); 
		}
		
		void SendRect(BRect rect, const char *desc = NULL, int32 type = DC_MESSAGE){
			str.SetTo("");
			if (desc != NULL) 	str << desc << ": "; else
								str << "Rectangle: ";
			str << "Left: " << rect.left  << " Top: " << rect.top
				<< " Right: " << rect.right << " Bottom: " << rect.bottom;
			SendMessage((char *)str.String(),type); 	
		}
		
	private:
		char *name;
		BString str;
};

#endif














